# Stairs AAN ===================================================================
rm(list=ls())
graphics.off()
cat('\014')
library(readr)

setwd("C:/Users/SWIENSLAB01/Desktop/AAN/data")

fps=dir(pattern="cal")
stairnr = 1
library(readr)
# read whole stair
tmp1 = read_delim(fps[stairnr], "\t", escape_double = FALSE, trim_ws = TRUE, skip = 5)
reversals = c(tmp1$fp[length(tmp1$fp)-2],tmp1$fp[length(tmp1$fp)-1],tmp1$fp[length(tmp1$fp)])
stairs = c(tmp1$trial[length(tmp1$trial)-2],tmp1$trial[length(tmp1$trial)-1],tmp1$trial[length(tmp1$trial)])
tmp1 = tmp1[-c(length(tmp1$fp)-2, length(tmp1$fp)-1, length(tmp1$fp)), ]

# store only critical trials
stair = tmp1[tmp1$cond==1,]
#guess = mean(reversals)
stable = 45
guess = mean(stair$level[stable:108])

par(mfrow=c(2,1))
#Plot stairs
plot(stair$level[stair$stair==-60], type = 'l', col = 'green',
     main = guess, xlab="Trial number", ylab="dB",
     xlim = c(0,length(stair$trial)/3), ylim = c(min(stair$level),max(stair$level)))
lines(stair$level[stair$stair==-80], col = 'blue')
lines(stair$level[stair$stair==-100], col = 'red')

abline(guess,0,lty=3)
abline(v = stable/3, lty = 2)
rm(fps)

# Psychometric response function ===============================================
glm_stair = glm(stair$subj_resp ~ stair$level, family = binomial(link = 'probit'))
x = seq(-100,-60, by = 0.1)
y = pnorm(glm_stair$coefficients[1]+glm_stair$coefficients[2]*x)
threshold_stair = (qnorm(0.5)-glm_stair$coefficients[1])/glm_stair$coefficients[2]
plot(stair$level,stair$subj_resp,main = threshold_stair)
lines(x, y)
abline(v = threshold_stair, lty = 1, col = 'red')
rm(x,y)

# Add val into it ==============================================================
fps=dir(pattern="val")
val = data.frame()
for (i in 1:length(fps)){
  tmp = read_delim(fps[i], "\t", escape_double = FALSE, trim_ws = TRUE, skip = 5)
  tmp = data.frame(tmp$level[tmp$cond == 1],tmp$aware[tmp$cond == 1])
  val = rbind(val,tmp)
  rm(tmp)
}
rm(i)
colnames(val) = c('level','aware')
tmp = data.frame(stair$level,stair$subj_resp)
colnames(tmp) = c('level','aware')
val = rbind(val,tmp)
rm(tmp)

glm_all = glm(val$aware ~ val$level, family = binomial(link = 'probit'))
x = seq(-100,-60, by = 0.1) #length.out = length(val$level)
y = pnorm(glm_all$coefficients[1]+glm_all$coefficients[2]*x)
threshold_all = (qnorm(0.5)-glm_all$coefficients[1])/glm_all$coefficients[2]
plot(val$level,val$aware, main = threshold_all)
lines(x, y)
abline(v = threshold_all, lty = 1, col = 'red')